'Compilable Example:
#Compiler PBWin 10
#Compile Exe "gbcatalog.exe"
#Debug Error On
#Debug Display On
#Dim All
%Unicode=1

#Include "win32api.inc"  'Jose Roca includes
#Include "cgdiplus.inc"
#Include "RichEdit.inc"
#Include "ListViewCtrl.inc"
#Include "WinInet.inc"

#Resource Manifest, 1, "files\xptheme.xml"

#Resource Icon, logo, "images\gbcatalog.ico"
#Resource Icon, xopen, "images\openhomepage.ico"
#Resource Icon, xsettings, "images\settings.ico"
#Resource Icon, xhelp, "images\help.ico"
#Resource Icon, xdlmany, "images\download_many.ico"
#Resource Icon, xdl, "images\download_one.ico"
#Resource Icon, xcheck, "images\checkfornew.ico"
#Resource Icon, xnextimage, "images\nextpicture.ico"
#Resource Icon, xresize, "images\resize.ico"
#Resource Icon, xweb, "images\web.ico"
#Resource Icon, xnextapp, "images\next.ico"
#Resource Icon, xpreviousapp, "images\previous.ico"
#Resource Icon, xfirst, "images\first.ico"
#Resource Icon, xlast, "images\last.ico"
#Resource Icon, xgray, "images\nextgray.ico"
#Resource Icon, xcategory, "images\category.ico"
#Resource Icon, xup, "images\sortascending.ico"
#Resource Icon, xdown, "images\sortdescending.ico"
#Resource Icon, xsearch, "images\search.ico"

$ver = "1.62"

Type AppData
   name As StringZ * %Max_Path
   ver As StringZ * %Max_Path
   author As StringZ * 50
   date As StringZ * %Max_Path
   rating As StringZ * 2
   homepage As StringZ * %Max_Path
   icon As StringZ * %Max_Path
   zip As StringZ * %Max_Path
   oneliner As StringZ * %Max_Path
   keywords As StringZ * %Max_Path
   desc As StringZ * 1000
   images As StringZ * 1000
   bullets As StringZ * 2000
End Type

%AllApps = 400
%PBApps  = 401
%VBApps  = 402

Enum Equates Singular
   IDC_ListView    = 500
   IDC_Toolbar
   IDC_AppIcon
   IDC_AppImage
   IDC_Desc
   IDC_Bullets
   IDC_NotReleased
   IDC_LabelV
   IDC_LabelWait
   IDC_StatusBar

   IDT_OpenDLFolder
   IDT_OpenHomePage
   IDT_Settings
   IDT_DataFile
   IDT_DLMany
   IDT_NextImage
   IDT_Resize
   IDT_NextApp
   IDT_PreviousApp
   IDT_Lastapp
   IDT_FirstApp
   IDT_Search
   IDT_Category
   IDT_Help

   IDM_Sep
   IDM_Information
   IDM_Unselect
   IDM_CheckAll
   IDM_UnCheckAll
   IDM_RefreshIcons
   IDM_RefreshImages
   IDM_RefreshOneIcon
   IDM_RefreshOneImage
   IDM_AutoUnSelect
   IDM_AutoOpenDLFolder
   IDM_Print
   IDM_ReloadLocalCatalog
   IDM_CenterImage
   IDM_ShrinkOnly
   IDM_VB
   IDM_PB
   IDM_All
   IDM_Description
   IDM_Test
   IDM_URLList
   IDM_ExportCatalog
   IDM_LargeFileWarning

   IDM_Games
   IDM_Graphics
   IDM_Internet
   IDM_Programming
   IDM_Utilities
   IDM_AllCategories
   IDM_NoCategories
   IDM_ValidateFiles
   IDM_ViewCatalog
   IDM_Copy

   IDM_RECut
   IDM_RECopy
   IDM_REPaste
   IDM_REDelete
   IDM_RESaveCatalog

   IDS_FindThisLabel
   IDS_FindThis
   IDS_CaseSensitive

End Enum

Global hDlg,hDlgs,hPopupSetting,ghHook,hListView,hPopupListView As Dword
Global hPopupCategory,hFont,hBMP,hWait,hImageList,hHeader,hREContext As Dword
Global SearchTerm, FontName As WStringZ * %Max_Path, hBullets,hDesc As Dword
Global SortDirection, FontSize,FontAttr,LastSelected As Long, CatalogVer As Single
Global ReSize,Picture,imgW,imgH,SplitVInWork, SortInWork, LoadListViewInWork As Long
Global VBarTop, CenterImage, Games, Utilities, Graphics, Programming, Internet As Long
Global CurrentImage, ShrinkOnly, AppTypes, SortColumnX,AutoUnSelect,AutoOpenDLFolder As Long
Global D() As AppData, DLPath As String
Global CaseSensitive,SearchDialogShown,MaxFileSize,LargeFileWarning As Long

Function PBMain() As Long
   Local style&
   style& = %WS_Child Or %WS_Visible Or %ES_MultiLine Or %ES_WantReturn Or _
            %WS_TabStop  Or %WS_ClipSiblings Or %WS_HScroll Or %WS_VScroll

   Dialog Font "Tahoma",10,0
   Dialog New Pixels, 0, "gbCatalog   v" + $ver,200,800,600,600, %WS_OverlappedWindow Or %WS_ClipChildren To hDlg
   Dialog Set Icon hDlg,"logo"

   CreateListView

   Graphic Bitmap New 1400,1400 To hBMP

   Control Add Graphic, hDlg, %IDC_AppIcon, "", 95,208,56,56,%WS_Border
   Graphic Attach hDlg, %IDC_AppIcon : Graphic Color %White,%White : Graphic Clear

   LoadLibrary("riched32.dll") : InitCommonControls
   Control Add "RichEdit", hDlg, %IDC_Desc, "",10,270,260,350, style&, %WS_Ex_ClientEdge Or %WS_Ex_Left
   Control Handle hDlg, %IDC_Desc To hDesc
   Control Add "RichEdit", hDlg, %IDC_Bullets, "",10,270,260,350, style&, %WS_Ex_ClientEdge Or %WS_Ex_Left
   Control Handle hDlg, %IDC_Bullets To hBullets
   Control Add Graphic, hDlg, %IDC_AppImage, "", 280,270,380,400

   Control Add Label, hDlg, %IDC_LabelV, "",  0,310, 600, 6, %SS_Notify , %WS_Ex_ClientEdge   ' left/right - does vertical split

   Control Add Statusbar, hDlg, %IDC_StatusBar, "Welcome to gbCatalog!", 0, 0, 0, 0
   Statusbar Set Parts hDlg, %IDC_StatusBar, 300,150,99999

   Dialog Show Modal hDlg Call DlgProc

End Function

Function MoveBarUpDown As Long
   'returns true if mouse moved vertically while button was down over the horizontal bar
   Local pt As Point, h As Long, w As Long
   Static oldY As Long
   Dialog Get Client hDlg To w,h
   GetCursorPos pt               'pt has xy screen coordinates
   ScreenToClient hDlg, pt       'pt now has client coordinates
   VBarTop = Max(150,Pt.y-3)
   If pt.y <> oldY Then Function = %True : oldY = pt.y
End Function

Sub ResizeWindow(Flag As Long)
   Local w,h,M,T,VTop As Long
   Dialog Get Client hDlg To w,h

   M = 5  'margin around controls
   T = 6  'splitter thickness (smallest dimension)
   VTop = VBarTop      'VTop will be position of horizontal bar

   'splitterbar colors - change colors when move is in work
   Control Set Color hDlg, %IDC_LabelV, %Black, IIf(SplitVInWork,%Gray,%Red)

   'resize splitterbars
   If Flag Or SplitVInWork Then
      Control Set Size hDlg, %IDC_LabelV, w - M - 5, T
      Control Set Loc hDlg, %IDC_LabelV, M, VTop
   End If

   If Flag Then
      ListView Set Column hDlg, %IDC_ListView, 5, w-407
      Control Set Size hDlg, %IDC_ListView, w-20, VTop - 70

      Control Set Loc hDlg, %IDC_AppIcon, 25, VTop + 15

      Control Set Loc hDlg, %IDC_Desc, 100, VTop + 15
      Control Set Size hDlg, %IDC_Desc, w-110, 56

      Control Set Loc hDlg, %IDC_Bullets, 10, VTop + 80 + 5
      Control Set Size hDlg, %IDC_Bullets, 260, h - VTop - 80 - 20 - 15

      Control Set Loc hDlg, %IDC_AppImage, 280, VTop + 80 + 5
      Control Set Size hDlg, %IDC_AppImage, w-290, h - VTop - 80 - 20 - 15

      Dialog ReDraw hDlg
   End If

End Sub

CallBack Function DlgProc() As Long
   Local temp$, w,h,iResult As Long, LVData As NM_ListView
   Local nmtb As TBNotify Ptr, rc As Rect, P As TooltipText Ptr
   Select Case CbMsg
      Case %WM_InitDialog
         CreateSubFolders
         BuildAcceleratorTable
         CreateToolbar
         CreatePopupMenus

         Settings_INI "get"
         SetMenuStatus

         ReadDataFile
         SortData
         LoadListView

         Font New FontName, FontSize, FontAttr To hFont

         If Len(Dir$("appicons\*.*")) = 0 Then
            DisplayWaitDialog hDlg, "Downloading icons."
            RefreshIcons
            Dialog End hWait
         End If
         If Len(Dir$("appimages\*.*")) = 0 Then
            DisplayWaitDialog hDlg, "Downloading images."
            RefreshImages
            Dialog End hWait
         End If

         Control Set Font hDlg, %IDC_Desc, hFont
         Control Set Font hDlg, %IDC_Bullets, hFont
         Control Set Font hDlg, %IDC_ListView, hFont

         PostMessage hDlg, %WM_User + 500, 0, 0

      Case %WM_User + 500
         ListView Get Count hDlg, %IDC_ListView To iResult
         ListView Select hDlg, %IDC_ListView, LastSelected
         ListView_SetItemState hListView, LastSelected-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
         ListView Visible hDlg, %IDC_ListView, LastSelected
         Control Set Focus hDlg, %IDC_ListView
         UpdateStatusBar

      Case %WM_Destroy
         ListView Get Select hDlg, %IDC_ListView To LastSelected : LastSelected = Max(LastSelected,1)
         Dialog Get Client hDlg To w,h
         Settings_INI "save"

      Case %WM_SetCursor
         iResult = GetDlgCtrlID (Cb.WParam)  'determine which over which label control mouse was moved
         If iResult = %IDC_LabelV Then MousePtr 7 : Function = 1    '7 = vertical cursor
         Select Case Hi(Word, Cb.LParam)
            Case %WM_LButtonDown
               If iResult = %IDC_LabelV Then SplitVInWork = 1 : ResizeWindow(0)
            Case %WM_MouseMove
               'Repositions splitter bars to match mouse position (if position has changed)
               If SplitVInWork Then If MoveBarUpDown Then ResizeWindow(0)
            Case %WM_LButtonUp
               If SplitVInWork Then
                  SplitVInWork = 0    'sets flags to say splitter action has ended
                  ResizeWindow(1) : DrawImage
'                  Dialog Redraw hDlg
               End If
         End Select

      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_RECut     : SendMessage GetFocus, %WM_CUT, 0, 0
            Case %IDM_RECopy    : SendMessage GetFocus, %WM_COPY, 0, 0
            Case %IDM_REPaste   : SendMessage GetFocus, %WM_PASTE, 0, 0
            Case %IDM_REDelete  : SendMessage GetFocus, %WM_CLEAR, 0, 0

            Case %IDM_RESaveCatalog
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
               If MessageBox(0, "Are you sure?", "Save Changes", %MB_OkCancel Or %MB_IconQuestion Or %MB_TaskModal) = %IdOk Then
                  ListView Get Select hDlg, %IDC_ListView To iResult
                  Control Get Text hDlg, %IDC_Desc To D(iResult).Desc
                  Control Get Text hDlg, %IDC_Bullets To D(iResult).Bullets
                  ExportCatalog Exe.Path$ + "files\gbcatalog.dat", 0   'save all, not just checked only
               End If
               UnhookWindowsHookEx ghHook

            Case %IDT_Search
               DisplaySearchDialog

            Case %IDT_DLMany
               If CheckCount = 0 Then
                  ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
                  MessageBox(0, "No apps checked!", "Download Apps", %MB_Ok + %MB_IconExclamation + %MB_TaskModal)
                  UnhookWindowsHookEx ghHook
               Else
                  DownloadCheckedZips
                  If AutoUnSelect Then CheckAll(0)
                  If AutoOpenDLFolder Then
                     temp$ = Exe.Path$ + "downloads"
                     iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)
                  End If
               End If

            Case %IDT_Lastapp
               ListView Get Select hDlg, %IDC_ListView To iResult
               If iResult = UBound(D) Then
                  Beep
               Else
                  iResult = UBound(D)
                  ListView Select hDlg, %IDC_Listview, iResult
                  ListView_SetItemState hListView, iResult-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
                  ListView Visible hDlg, %IDC_ListView, iResult
               End If

            Case %IDT_NextApp
               ListView Get Select hDlg, %IDC_ListView To iResult
               If iResult = UBound(D) Then
                  Beep
               Else
                  Incr iResult  'iResult = Min(iResult+1,UBound(D))
                  ListView Select hDlg, %IDC_Listview, iResult
                  ListView_SetItemState hListView, iResult-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
                  ListView Visible hDlg, %IDC_ListView, iResult
               End If

            Case %IDT_PreviousApp
               ListView Get Select hDlg, %IDC_ListView To iResult
               If iResult = 1 Then
                  Beep
               Else
                  Decr iResult   'iResult = Max(iResult-1,1)
                  ListView Select hDlg, %IDC_Listview, iResult
                  ListView_SetItemState hListView, iResult-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
                  ListView Visible hDlg, %IDC_ListView, iResult
               End If

            Case %IDT_FirstApp
               ListView Get Select hDlg, %IDC_ListView To iResult
               If iResult = 1 Then
                  Beep
               Else
                  iResult = 1
                  ListView Select hDlg, %IDC_Listview, iResult
                  ListView_SetItemState hListView, iResult-1, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
                  ListView Visible hDlg, %IDC_ListView, iResult
               End If

            Case %IDT_OpenDLFolder
               temp$ = Exe.Path$ + "downloads"
               iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDT_OpenHomePage
               ListView Get Select hDlg, %IDC_ListView To iResult
               iResult = ShellExecute(hDlg, "Open", (D(iResult).homepage), $Nul, $Nul, %SW_ShowNormal)


            Case %IDT_DataFile
               UpdateDATFile

            Case %IDT_Settings
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
               temp$ = "Catalog Version:  " + $Tab + $Tab + "v" + Format$(CatalogVer,"0.00") + $CrLf + $CrLf + _
                       "Apps Displayed:   " + $Tab + $Tab + Format$(UBound(D),"##0") + $CrLf + $CrLf + _
                       "Icons (checked apps):" + $Tab + Format$(CheckCount,"##0") + $CrLf + _
                       "Images (checked apps):" + $Tab + Format$(ImageCount,"##0")
               MessageBox(0, (temp$), "Settings", %MB_Ok + %MB_IconQuestion)
               UnhookWindowsHookEx ghHook

            Case %IDT_NextImage
               ListView Get Select hDlg, %IDC_ListView To iResult
               temp$ = D(iResult).images
               If ParseCount(temp$,";") > 1 Then
                  Incr CurrentImage
                  If CurrentImage > ParseCount(temp$,";") Then CurrentImage = 1
                  DisplaySelection
                  UpdateStatusBar
               End If

            Case %IDT_Resize : Resize = Resize Xor 1   : SetMenuStatus : DrawImage

            Case %IDT_Help
                 temp$ = "http://www.garybeene.com/sw/gbcatalog.htm"
                 iResult = ShellExecute(hDlg, "Open", (temp$), $Nul, $Nul, %SW_ShowNormal)

            Case %IDM_CheckAll   :  CheckAll(1)
            Case %IDM_UncheckAll :  CheckAll(0)

            Case %IDM_Description : DisplayDescription

            Case %IDM_Copy : CopyAll

            Case %IDM_RefreshOneIcon
               RefreshOneIcon
               CurrentImage = 1
               DisplaySelection
               UpdateStatusBar

            Case %IDM_RefreshIcons
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
               If MessageBox(0, "Download" + Str$(CheckCount) + " icons. Are you sure?","Download Icons", %MB_OkCancel + %MB_IconQuestion) = %IdOk Then
                  DisplayWaitDialog hDlg, "Downloading icons."
                  RefreshIcons
                  Dialog End hWait
                  CurrentImage = 1
                  DisplaySelection
                  UpdateStatusBar
                  ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
                  MessageBox(0, "Icon download complete!", "Download Icons", %MB_Ok Or %MB_IconInformation Or %MB_TaskModal)
                  UnhookWindowsHookEx ghHook
                End If
                UnhookWindowsHookEx ghHook

            Case %IDM_RefreshOneImage  'actually, all the images for one application
               RefreshOneImage
               CurrentImage = 1
               DisplaySelection
               UpdateStatusBar

            Case %IDM_RefreshImages
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
               If MessageBox (0, "Download" + Str$(ImageCount) + " images. Are you sure?", "Download Images",  %MB_OkCancel + %MB_IconQuestion) = %IdOk Then
                  DisplayWaitDialog hDlg, "Download images."
                  RefreshImages
                  Dialog End hWait
                  CurrentImage = 1
                  DisplaySelection
                  UpdateStatusBar
                  ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
                  MessageBox(0, "Image download complete!", "Download Checked Images", %MB_Ok Or %MB_IconInformation Or %MB_TaskModal)
                  UnhookWindowsHookEx ghHook
               End If
               UnhookWindowsHookEx ghHook

            Case %IDM_Print         : PrintListView

            Case %IDM_Information
               ListView Get Select hDlg, %IDC_ListView To iResult
               temp$ = D(iResult).images
               Replace ";" With $CrLf In temp$
               ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
               MessageBox (0, D(iResult).desc + $CrLf + $CrLf + D(iResult).keywords + $CrLf + D(iResult).homepage + $CrLf + D(iResult).zip + _
                    $CrLf + $CrLf + D(iResult).icon + $CrLf + temp$, "Application Description", %MB_Ok + %MB_IconInformation)
               UnhookWindowsHookEx ghHook

            Case %IDM_UnSelect
               ListView Get Select hDlg, %IDC_ListView To iResult
               ListView Unselect hDlg, %IDC_ListView, iResult

            Case %IDM_CenterImage
               CenterImage = CenterImage Xor 1
               SetMenuStatus
               DrawImage

            Case %IDM_LargeFileWarning
               LargeFileWarning Xor= 1
               SetMenuStatus
               DrawImage

            Case %IDM_AutoUnSelect
               AutoUnSelect Xor= 1
               SetMenuStatus

            Case %IDM_AutoOpenDLFolder
               AutoOpenDLFolder Xor= 1
               SetMenuStatus

            Case %IDM_ShrinkOnly
               ShrinkOnly = ShrinkOnly Xor 1
               SetMenuStatus
               DisplaySelection
               UpdateStatusBar

            Case %IDM_All
               AppTypes = %AllApps : SetMenuStatus : ReadDataFile : SortData : LoadListView : ListView Select hDlg, %IDC_Listview, 1 : UpdateStatusBar
               ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
            Case %IDM_PB
               AppTypes = %PBApps  : SetMenuStatus : ReadDataFile : SortData : LoadListView : ListView Select hDlg, %IDC_Listview, 1 : UpdateStatusBar
               ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
            Case %IDM_VB
               AppTypes = %VbApps  : SetMenuStatus : ReadDataFile : SortData : LoadListView : ListView Select hDlg, %IDC_Listview, 1 : UpdateStatusBar
               ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code

            Case %IDM_NoCategories
               Games = 0 : Graphics = 0 : Programming = 0 : Utilities = 0 : Internet = 0
               SetMenuStatus
               ReadDataFile
               SortData
               LoadListView
               ListView Select hDlg, %IDC_ListView, 1 : DisplaySelection : UpdateStatusBar
               ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code

            Case %IDT_Category, %IDM_AllCategories
               'Games = 1 : Graphics = 1 : Programming = 1 : Utilities = 1 : Internet = 1
               SetMenuStatus
               ReadDataFile
               SortData
               LoadListView
               ListView Select hDlg, %IDC_ListView, 1 : DisplaySelection : UpdateStatusBar
               ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code

            Case %IDM_Games
               Games = Games Xor 1
               SetMenuStatus
               ReadDataFile
               SortData
               LoadListView
               ListView Select hDlg, %IDC_ListView, 1 : DisplaySelection : UpdateStatusBar
               ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code

            Case %IDM_Graphics
               Graphics = Graphics Xor 1
               SetMenuStatus
               ReadDataFile
               SortData
               LoadListView
               ListView Select hDlg, %IDC_ListView, 1 : DisplaySelection : UpdateStatusBar
               ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code

            Case %IDM_Internet
               Internet = Internet Xor 1
               SetMenuStatus
               ReadDataFile
               SortData
               LoadListView
               ListView Select hDlg, %IDC_ListView, 1 : DisplaySelection : UpdateStatusBar
               ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code

            Case %IDM_Programming
               Programming = Programming Xor 1
               SetMenuStatus
               ReadDataFile
               SortData
               LoadListView
               ListView Select hDlg, %IDC_ListView, 1 : DisplaySelection : UpdateStatusBar
               ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code

            Case %IDM_Utilities
               Utilities = Utilities Xor 1
               SetMenuStatus
               ReadDataFile
               SortData
               LoadListView
               ListView Select hDlg, %IDC_ListView, 1 : DisplaySelection : UpdateStatusBar
               ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code

            Case %IDM_ReloadLocalCatalog
               ReadDataFile
               SortData
               LoadListView
               LastSelected = 1
               ListView Select hDlg, %IDC_ListView, 1
               ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
               ListView Visible hDlg, %IDC_ListView, LastSelected
               Control Set Focus hDlg, %IDC_ListView

            Case %IDM_ValidateFiles : ValidateServerFiles

            Case %IDM_ViewCatalog
               iResult  = Shell ("Notepad " + Exe.Path$ + "files\gbcatalog.dat", 1)  'opens Notepad, does not wait for it to close

            Case %IDM_URLList : SaveURLList

            Case %IDM_Test
               'ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
               'MessageBox(0, "Image count: " + Str$(ImageCount), "Get Image Count", %MB_Ok Or %MB_IconInformation Or %MB_TaskModal)
               'UnhookWindowsHookEx ghHook

            Case %IDM_ExportCatalog : ExportCatalog Exe.Path$ + "files\gbexport.dat", 1   'save checked only

         End Select

      Case %WM_Size : ResizeWindow(1) : DrawImage

      Case %WM_ContextMenu
         w = Lo(Integer,Cb.LParam) : h = Hi(Integer, Cb.LParam)
         iResult = GetDlgCtrlID (Cb.WParam)             'get control ID
         Select Case iResult
            Case %IDC_ListView
               ListView Get Select hDlg, %IDC_ListView To iResult
               If iResult Then TrackPopupMenu hPopupListView, %TPM_LeftAlign, w, h, 0, Cb.Hndl, ByVal 0
            Case %IDC_Bullets
               TrackPopupMenu hREContext, %TPM_LeftAlign, w, h, 0, Cb.Hndl, ByVal 0
            Case %IDC_Desc
               TrackPopupMenu hREContext, %TPM_LeftAlign, w, h, 0, Cb.Hndl, ByVal 0
         End Select

      Case %WM_Notify
           nmtb = Cb.LParam
           Select Case @nmtb.hdr.Code
              Case %TBN_DROPDOWN
                 Select Case @nmtb.iItem
                    Case %IDT_Settings
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupSetting, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                    Case %IDT_Category
                       Call SendMessage(@nmtb.hdr.hwndFrom, %TB_GETRECT, @nmtb.iItem, VarPtr(rc))
                       Call MapWindowPoints(@nmtb.hdr.hwndFrom, %HWND_Desktop, ByVal VarPtr(rc), 2)
                       Call TrackPopupMenu (hPopupCategory, 0, rc.nLeft, rc.nBottom, 0, CbHndl, ByVal %Null)
                 End Select
           End Select

           Select Case Cb.NmId
               Case %IDT_OpenDLFolder To %IDT_Help
                  Select Case Cb.NmCode
                     Case %TTN_GetDispInfo
                         P = Cb.LParam
                         @P.@lpszText = SetToolTips(Cb.NmId)
                  End Select
               Case %IDC_ListView
                  Select Case Cb.NmCode
'                     Case %NM_Click  '%LVN_ItemChanged
                     Case %LVN_ItemChanged
                        If SortInWork Then Exit Select
                        CurrentImage = 1
                        GrayOutNextImage
                        DisplaySelection
                        UpdateStatusBar

                     Case %NM_DblClk
                        DisplayDescription

                     Case %LVN_ColumnClick
                        SortInWork = 1
                        Type Set LVData = Cb.NmHdr$(SizeOf(LVData))
                        SortDirection = SortDirection Xor 1
                        SortColumnX = LVData.iSubItem+1
                        SortData
                        LoadListView
                        ListView Select hDlg, %IDC_ListView, 1
                        ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
                        DisplaySelection
                        UpdateStatusBar
                        SortInWork = 0
                  End Select
         End Select

   End Select
End Function

Sub Settings_INI(Task$)
   Local x,y As Long, xResult, yResult, INIFileName, tempz As WStringZ * %Max_Path
   INIFileName = Exe.Path$ + "gbcatalog.ini"
   'set ini filename
   If Task$ = "get" Then
      'get dialog top/left from INI file and use to set Dialog location
      Getprivateprofilestring "All", "Left", "300", xResult, %Max_Path, INIFileName
      Getprivateprofilestring "All", "Top", "300", yResult, %Max_Path, INIFileName
      Dialog Set Loc hDlg, Val(xResult), Val(yResult)   'left/top

      'get dialog width/height from INI file and use to set Dialog size
      GetPrivateProfileString "All", "Width", "730", xResult, %Max_Path, INIFileName
      GetPrivateProfileString "All", "Height", "520", yResult, %Max_Path, INIFileName
      Dialog Set Client hDlg,Val(xResult), Val(yResult)   'width/height

      'get value for string variables
      Getprivateprofilestring "All", "FontName", "Tahoma", tempz, %Max_Path, INIFileName : FontName = tempz
      Getprivateprofilestring "All", "SearchTerm", "search", tempz, %Max_Path, INIFileName : SearchTerm = tempz

      'get value for numeric variables
      Getprivateprofilestring "All", "FontSize", "10", tempz, %Max_Path, INIFileName:  FontSize = Val(tempz)
      Getprivateprofilestring "All", "FontAttr", "0", tempz, %Max_Path, INIFileName:  FontAttr = Val(tempz)
      Getprivateprofilestring "All", "Picture", Str$(1), tempz, %Max_Path, INIFileName:  Picture = Val(tempz)
      Getprivateprofilestring "All", "Resize", "1", tempz, %Max_Path, INIFileName:  ReSize = Val(tempz)
      Getprivateprofilestring "All", "LastSelected", "1", tempz, %Max_Path, INIFileName:  LastSelected = Val(tempz)
      Getprivateprofilestring "All", "VBarTop", "200", tempz, %Max_Path, INIFileName:  VBarTop = Val(tempz)
      Getprivateprofilestring "All", "ShrinkOnly", "1", tempz, %Max_Path, INIFileName:  ShrinkOnly = Val(tempz)
      Getprivateprofilestring "All", "AppTypes", Str$(%AllApps), tempz, %Max_Path, INIFileName:  AppTypes = Val(tempz)
      Getprivateprofilestring "All", "CenterImage", "1", tempz, %Max_Path, INIFileName:  CenterImage = Val(tempz)
      Getprivateprofilestring "All", "Games", "1", tempz, %Max_Path, INIFileName:  Games = Val(tempz)
      Getprivateprofilestring "All", "Graphics", "1", tempz, %Max_Path, INIFileName:  Graphics = Val(tempz)
      Getprivateprofilestring "All", "Programming", "1", tempz, %Max_Path, INIFileName:  Programming = Val(tempz)
      Getprivateprofilestring "All", "Utilities", "1", tempz, %Max_Path, INIFileName:  Utilities = Val(tempz)
      Getprivateprofilestring "All", "Internet", "1", tempz, %Max_Path, INIFileName:  Internet = Val(tempz)
      Getprivateprofilestring "All", "SortDirection", "0", tempz, %Max_Path, INIFileName:  SortDirection = Val(tempz)
      Getprivateprofilestring "All", "SortColumn", "1", tempz, %Max_Path, INIFileName:  SortColumnX = Val(tempz)
      Getprivateprofilestring "All", "AutoUnSelect", "0", tempz, %Max_Path, INIFileName:  AutoUnSelect = Val(tempz)
      Getprivateprofilestring "All", "AutoOpenDLFolder", "0", tempz, %Max_Path, INIFileName:  AutoOpenDLFolder = Val(tempz)
      Getprivateprofilestring "All", "MaxFileSize", "5", tempz, %Max_Path, INIFileName:  MaxFileSize = Val(tempz)
      Getprivateprofilestring "All", "LargeFileWarning", "1", tempz, %Max_Path, INIFileName:  LargeFileWarning = Val(tempz)
   End If

   If Task$ = "save" Then
      If Len(Dir$(INIFileName)) Then Kill INIFileName
      'save dialog size/location unless minimized or maximized
      If IsFalse(IsIconic(hDlg) Or IsZoomed(hDlg)) Then
         Dialog Get Loc hDlg To x,y
         WritePrivateProfileString "All", "Left", Str$(x), INIFileName
         WritePrivateProfileString "All", "Top", Str$(y), INIFileName
         Dialog Get Client hDlg To x,y
         WritePrivateProfileString "All", "Width", Str$(x), INIFileName
         WritePrivateProfileString "All", "Height", Str$(y), INIFileName
      End If
      'save string variables
      WritePrivateProfileString "All", "FontName",FontName, INIFileName
      WritePrivateProfileString "All", "SearchTerm",SearchTerm, INIFileName

      'save numeric variables
      WritePrivateProfileString "All", "FontSize", (Str$(FontSize)), INIFileName
      WritePrivateProfileString "All", "FontAttr", (Str$(FontAttr)), INIFileName
      WritePrivateProfileString "All", "Picture", (Str$(Picture)), INIFileName
      WritePrivateProfileString "All", "Resize", (Str$(Resize)), INIFileName
      WritePrivateProfileString "All", "LastSelected", (Str$(LastSelected)), INIFileName
      WritePrivateProfileString "All", "VBarTop", (Str$(VBarTop)), INIFileName
      WritePrivateProfileString "All", "ShrinkOnly", (Str$(ShrinkOnly)), INIFileName
      WritePrivateProfileString "All", "AppTypes", (Str$(AppTypes)), INIFileName
      WritePrivateProfileString "All", "CenterImage", (Str$(CenterImage)), INIFileName
      WritePrivateProfileString "All", "Games", (Str$(Games)), INIFileName
      WritePrivateProfileString "All", "Graphics", (Str$(Graphics)), INIFileName
      WritePrivateProfileString "All", "Programming", (Str$(Programming)), INIFileName
      WritePrivateProfileString "All", "Utilities", (Str$(Utilities)), INIFileName
      WritePrivateProfileString "All", "Internet", (Str$(Internet)), INIFileName
      WritePrivateProfileString "All", "SortDirection", (Str$(SortDirection)), INIFileName
      WritePrivateProfileString "All", "SortColumn", (Str$(SortColumnX)), INIFileName
      WritePrivateProfileString "All", "AutoUnSelect", (Str$(AutoUnSelect)), INIFileName
      WritePrivateProfileString "All", "AutoOpenDLFolder", (Str$(AutoOpenDLFolder)), INIFileName
      WritePrivateProfileString "All", "MaxFileSize", (Str$(MaxFileSize)), INIFileName
      WritePrivateProfileString "All", "LargeFileWarning", (Str$(LargeFileWarning)), INIFileName
   End If
End Sub


Sub SetMenuStatus
   'Toolbar Buttons
   Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_Resize, %TBState_Checked * Resize Or %TBState_Enabled

   'Popup Menus
    Menu Set State hPopupCategory, ByCmd %IDM_Games, Games * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupCategory, ByCmd %IDM_Graphics, Graphics * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupCategory, ByCmd %IDM_Programming, Programming * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupCategory, ByCmd %IDM_Internet, Internet * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupCategory, ByCmd %IDM_Utilities, Utilities * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSetting, ByCmd %IDM_AutoUnSelect, AutoUnSelect * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSetting, ByCmd %IDM_AutoOpenDLFolder, AutoOpenDLFolder * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSetting, ByCmd %IDM_CenterImage, CenterImage * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSetting, ByCmd %IDM_ShrinkOnly, ShrinkOnly * (%MFS_Checked Or %MFS_Enabled)
    Menu Set State hPopupSetting, ByCmd %IDM_LargeFileWarning, LargeFileWarning * (%MFS_Checked Or %MFS_Enabled)

    Menu Set State hPopupCategory, ByCmd %IDM_All, 0
    Menu Set State hPopupCategory, ByCmd %IDM_PB, 0
    Menu Set State hPopupCategory, ByCmd %IDM_VB, 0
    Select Case AppTypes
       Case %AllApps : Menu Set State hPopupCategory, ByCmd %IDM_All, %MFS_Checked Or %MFS_Enabled
       Case %PBApps  : Menu Set State hPopupCategory, ByCmd %IDM_PB, %MFS_Checked Or %MFS_Enabled
       Case %VBApps  : Menu Set State hPopupCategory, ByCmd %IDM_VB, %MFS_Checked Or %MFS_Enabled
    End Select
End Sub

Sub BuildAcceleratorTable
   Local c As Long, ac() As ACCELAPI, hAccelerator As Dword  ' for keyboard accelator table values
   Dim ac(18)
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F1 : ac(c).cmd   = %IDT_Help          : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F2 : ac(c).cmd   = %IDT_Category      : Incr c
   ac(c).fvirt = %FVIRTKEY              : ac(c).key   = %VK_F3 : ac(c).cmd   = %IDT_Search        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_A  : ac(c).cmd   = %IDM_CheckAll      : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_D  : ac(c).cmd   = %IDM_Description   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_E  : ac(c).cmd   = %IDM_ExportCatalog : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_F  : ac(c).cmd   = %IDT_Search        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_H  : ac(c).cmd   = %IDT_OpenHomePage  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_I  : ac(c).cmd   = %IDT_NextImage     : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_L  : ac(c).cmd   = %IDM_Copy          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_N  : ac(c).cmd   = %IDT_NextApp       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_O  : ac(c).cmd   = %IDT_OpenDLFolder  : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_P  : ac(c).cmd   = %IDT_PreviousApp   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_R  : ac(c).cmd   = %IDT_Resize        : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_S  : ac(c).cmd   = %IDM_RESaveCatalog : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_T  : ac(c).cmd   = %IDM_Test          : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_U  : ac(c).cmd   = %IDM_URLList       : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Y  : ac(c).cmd   = %IDM_ViewCatalog   : Incr c
   ac(c).fvirt = %FVIRTKEY Or %FCONTROL : ac(c).key   = %VK_Z  : ac(c).cmd   = %IDT_Category      : Incr c
   Accel Attach hDlg, AC() To hAccelerator
End Sub

Sub CreateToolbar
    Local hGrayList,hImageList,hToolbar As Dword
    ImageList New Icon 24,24,24,20 To hGrayList
    ImageList Add Icon hGrayList, "xgray"     '1

    ImageList New Icon 24,24,24,20 To hImageList
    ImageList Add Icon hImageList, "xnextimage" '1
    ImageList Add Icon hImageList, "xdl"        '2
    ImageList Add Icon hImageList, "xdlmany"    '3
    ImageList Add Icon hImageList, "xopen"      '4
    ImageList Add Icon hImageList, "xfirst"     '5
    ImageList Add Icon hImageList, "xpreviousapp" '6
    ImageList Add Icon hImageList, "xnextapp"   '7
    ImageList Add Icon hImageList, "xlast"      '8

    ImageList Add Icon hImageList, "xcheck"     '9
    ImageList Add Icon hImageList, "xresize"    '10
    ImageList Add Icon hImageList, "xweb"       '11
    ImageList Add Icon hImageList, "xsettings"  '12

    ImageList Add Icon hImageList, "xhelp"      '13
    ImageList Add Icon hImageList, "xcategory"  '14
    ImageList Add Icon hImageList, "xsearch"    '15

    Control Add Toolbar, hDlg, %IDC_Toolbar,"", 0,0,0,0, %TbStyle_Tooltips Or %TbStyle_Flat Or %WS_Child
    Control Handle hDlg, %IDC_Toolbar To hToolbar
    SendMessage hToolbar, %TB_SETEXTENDEDSTYLE, 0, %TBSTYLE_EX_DRAWDDARROWS

    Toolbar Set ImageList hDlg, %IDC_Toolbar, hImageList, 0     'default imagelist
    Toolbar Set ImageList hDlg, %IDC_Toolbar, hGrayList, 1     'default imagelist


    Toolbar Add Button  hDlg, %IDC_Toolbar, 9, %IDT_DataFile,  %TbStyle_Button, "Update"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 15
    Toolbar Add Button  hDlg, %IDC_Toolbar, 3, %IDT_DLMany,  %TbStyle_Button, "DL"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 4, %IDT_OpenDLFolder,  %TbStyle_Button, "Open"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 15
    Toolbar Add Button  hDlg, %IDC_Toolbar, 5, %IDT_FirstApp,  %TbStyle_Button, "First"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 6, %IDT_PreviousApp,  %TbStyle_Button, "Prev"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 7, %IDT_NextApp,  %TbStyle_Button, "Next"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 8, %IDT_LastApp,  %TbStyle_Button, "Last"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 15, %IDT_Search,  %TbStyle_Button, "Search"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 15
    Toolbar Add Button  hDlg, %IDC_Toolbar, 1, %IDT_NextImage,  %TbStyle_Button, "Image"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 15
    Toolbar Add Button  hDlg, %IDC_Toolbar, 10, %IDT_ReSize,  %TbStyle_Check, "ReSize"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 14, %IDT_Category,  %TbStyle_Button Or %TbStyle_DropDown, "Category"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 12, %IDT_Settings,  %TbStyle_Button Or %TbStyle_DropDown, "Settings"
    Toolbar Add Separator hDlg, %IDC_Toolbar, 15
    Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDT_OpenHomePage,  %TbStyle_Button, "gbApp"
    Toolbar Add Button  hDlg, %IDC_Toolbar, 13, %IDT_Help,  %TbStyle_Button, "Help"
End Sub

Sub CreatePopupMenus
    Menu New PopUp To hREContext
    Menu Add String, hREContext, "Cut",  %IDM_RECut,  %MF_Enabled
    Menu Add String, hREContext, "Copy",  %IDM_RECopy,  %MF_Enabled
    Menu Add String, hREContext, "Paste",  %IDM_REPaste,  %MF_Enabled
    Menu Add String, hREContext, "Delete",  %IDM_REDelete,  %MF_Enabled
    Menu Add String, hREContext, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hREContext, "Save Changes",  %IDM_RESaveCatalog,  %MF_Enabled

    Menu New PopUp To hPopupCategory
    Menu Add String, hPopupCategory, "Games",  %IDM_Games,  %MF_Enabled
    Menu Add String, hPopupCategory, "Graphics",  %IDM_Graphics,  %MF_Enabled
    Menu Add String, hPopupCategory, "Internet",  %IDM_Internet,  %MF_Enabled
    Menu Add String, hPopupCategory, "Programming",  %IDM_Programming,  %MF_Enabled
    Menu Add String, hPopupCategory, "Utilities",  %IDM_Utilities,  %MF_Enabled
    Menu Add String, hPopupCategory, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupCategory, "Select All Categories",  %IDM_AllCategories,  %MF_Enabled
    Menu Add String, hPopupCategory, "Unselect All Categories",  %IDM_NoCategories,  %MF_Enabled
    Menu Add String, hPopupCategory, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupCategory, "All Apps",  %IDM_All,  %MF_Enabled
    Menu Add String, hPopupCategory, "PowerBASIC Apps Only",  %IDM_PB,  %MF_Enabled
    Menu Add String, hPopupCategory, "VB6 Apps Only",  %IDM_VB,  %MF_Enabled

    Menu New PopUp To hPopupListView
    Menu Add String, hPopupListView, "Check All",  %IDM_CheckAll,  %MF_Enabled
    Menu Add String, hPopupListView, "UnCheck All",  %IDM_UnCheckAll,  %MF_Enabled
    Menu Add String, hPopupListView, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupListView, "Display Application Description",  %IDM_Information,  %MF_Enabled
    Menu Add String, hPopupListView, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupListView, "Download Icon for Selected Application",  %IDM_RefreshOneIcon,  %MF_Enabled
    Menu Add String, hPopupListView, "Download Images for Selected Application",  %IDM_RefreshOneImage,  %MF_Enabled

    Menu New PopUp To hPopupSetting
    Menu Add String, hPopupSetting, "Print Checked Apps In List",  %IDM_Print,  %MF_Enabled
    Menu Add String, hPopupSetting, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupSetting, "View/Edit Local Catalog File",  %IDM_ViewCatalog,  %MF_Enabled
    Menu Add String, hPopupSetting, "Reload Local Catalog",  %IDM_ReloadLocalCatalog,  %MF_Enabled
    Menu Add String, hPopupSetting, "Save Changes",  %IDM_RESaveCatalog,  %MF_Enabled
    Menu Add String, hPopupSetting, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupSetting, "Download All Icons (Checked Apps Only)",  %IDM_RefreshIcons,  %MF_Enabled
    Menu Add String, hPopupSetting, "Download All Images (Checked Apps Only)",  %IDM_RefreshImages,  %MF_Enabled
    Menu Add String, hPopupSetting, "-",  %IDM_Sep,  %MF_Enabled
    Menu Add String, hPopupSetting, "Resize Large Images Only",  %IDM_ShrinkOnly,  %MF_Enabled
    Menu Add String, hPopupSetting, "Center Images",  %IDM_CenterImage,  %MF_Enabled
    Menu Add String, hPopupSetting, "UnCheck Apps on File Download",  %IDM_AutoUnSelect,  %MF_Enabled
    Menu Add String, hPopupSetting, "Open Download Folder After Download",  %IDM_AutoOpenDLFolder,  %MF_Enabled
    Menu Add String, hPopupSetting, "Large File Warning",  %IDM_LargeFileWarning,  %MF_Enabled
End Sub

Function SetToolTips(cID As Long) As String
   Select Case cID          'or this:   @P.hdr.idFrom
      Case %IDT_DataFile      : Function = "Check for Updated Catalog Information"

      Case %IDT_DLMany        : Function = "Download All Checked Applications"
      Case %IDT_OpenDLFolder  : Function = "Open Download Folder"

      Case %IDT_NextApp       : Function = "View Next App"
      Case %IDT_PreviousApp   : Function = "View Previous App"

      Case %IDT_NextApp        : Function = "GoTo Next App"
      Case %IDT_PreviousApp    : Function = "GoTo Previous App"
      Case %IDT_Lastapp        : Function = "GoTo Last App"
      Case %IDT_FirstApp       : Function = "GoTo First App"

      Case %IDT_Category       : Function = "Display All Categories"

      Case %IDT_NextImage     : Function = "Display Next App Image"
      Case %IDT_Resize        : Function = "Resize App Image to Fit Window"

      Case %IDT_Settings      : Function = "Display Display Summary"
      Case %IDT_OpenHomePage  : Function = "Open Home Page of Selected Application"
      Case %IDT_Help          : Function = "Open gbCatalog OnLine Help"
   End Select
End Function



Sub SelectMainFont
   Local fName As String, fPoints, fStyle, fColor, CharSet, Style As Long
   Style = %CF_ScreenFonts Or %CF_ForceFontExist Or %CF_NoScriptSel Or %CF_NoSimulations 'Or %CF_FixedPitchOnly
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(FontDialogProc), GetModuleHandle(""), GetCurrentThreadId)
   Display Font hDlg, 100,100, FontName, FontSize, FontAttr, Style To fName, fPoints, fStyle, fColor, CharSet
   If Len(fName) Then
      FontName = fName : FontSize = fPoints : FontAttr = fStyle
      Font New FontName, FontSize, FontAttr To hFont
   End If
End Sub

Function FontDialogProc(ByVal nCode As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    Local szTemp As WStringZ * %Max_Path, cw As CBT_CREATEWND Ptr, cst As CREATESTRUCT Ptr
    Function = CallNextHookEx(ByVal ghHook, ByVal nCode, ByVal wParam, ByVal lParam)
    If nCode < 0 Then Exit Function
    If nCode = %HCBT_ACTIVATE Then UnhookWindowsHookEx ghHook
    If nCode = %HCBT_CREATEWND Then
        cw = lParam         ' Get pointer to CBT_CREATEWND struct so we can...    TT: Nick Melnick
        cst = @cw.lpcs      ' get a pointer to the CREATESTRUCT struct
        GetClassName wParam, szTemp, %Max_Path      ' for each window / control as it is created
        If UCase$(szTemp) = "#32770" Then @cst.cy = @cst.cy - 165 : @cst.cx = @cst.cx - 10  'dialog
    End If
End Function

Sub CopyAll
   Local i, iCount As Long, temp$, tmp$
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      ListView Get Text hDlg, %IDC_ListView,i,1 To tmp$
      temp$ = temp$ + $CrLf + tmp$
      ListView Get Text hDlg, %IDC_ListView,i,4 To tmp$
      temp$ = temp$ + " - " + tmp$
   Next i
   Clipboard Reset
   Clipboard Set Text temp$
End Sub

Sub CheckAll(Flag As Long)
   Local i, iCount As Long
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      ListView_SetCheckState hListView, i-1, Flag
   Next i
End Sub

Sub ReadDataFile
On Error GoTo ReadError

   Local iCount,Flag As Long, temp$, tmp$
   ReDim D(1000)
   Open Exe.Path$ + "files\gbcatalog.dat" For Input As #1
   Line Input #1, temp$
   CatalogVer = Val(temp$)

   While IsFalse(Eof(1))
      Line Input #1,  temp$
      Select Case Left$(temp$,5)
         Case "=000="
            Incr iCount
            Line Input #1, D(iCount).name
            Line Input #1, D(iCount).ver
            Line Input #1, D(iCount).date
            Line Input #1, D(iCount).homepage
            Line Input #1, D(iCount).icon
            Line Input #1, D(iCount).zip
            Line Input #1, D(iCount).oneliner
            Line Input #1, D(iCount).keywords
            Line Input #1, tmp$ : D(iCount).rating = Left$(Trim$(tmp$),1)
            Line Input #1, D(iCount).author
         Case "=111="
            'read bullets
            Line Input #1, temp$
            While Left$(temp$,5) <> "=111="
               D(iCount).bullets = D(iCount).bullets + $CrLf + temp$
               Line Input #1, temp$
            Wend
            D(iCount).bullets = Mid$(D(iCount).bullets,3)
         Case "=222="
            'read description
            Line Input #1, temp$
            While Left$(temp$,5) <> "=222="
               D(iCount).desc = D(iCount).desc + $CrLf + temp$
               Line Input #1, temp$
            Wend
            D(iCount).desc = Mid$(D(iCount).desc,3)
         Case "=333="
           'read image URLs
            Line Input #1, temp$
            While Left$(temp$,5) <> "=333="
               D(iCount).images = D(iCount).images + ";" + temp$
               Line Input #1, temp$
            Wend
            D(iCount).images = Mid$(D(iCount).images,2)
      End Select
   Wend
   Close #1
   ReDim Preserve D(iCount)
   Array Sort D(1), Call SortAName
   RemoveAppTypes
   RemoveCategories

Exit Sub
ReadError:

ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
MessageBox(0, "Error: " + Str$(iCount) + "  " + D(iCount).name, "Read Catalog Data", %MB_Ok Or %MB_IconInformation Or %MB_TaskModal)
UnhookWindowsHookEx ghHook

End Sub

Sub RemoveCategories
   Local i,iCount, Flag As Long
   If Games And Graphics And Programming And Utilities And Internet Then Exit Sub  'if all chosen, remove none
   'remove app categories as required
   For i = UBound(D) To 1 Step -1
      Flag = 0
      If Games = 1 And InStr(D(i).keywords, "game") Then
         Flag = 1
      ElseIf Graphics = 1 And InStr(D(i).keywords, "graphics") Then
         Flag = 1
      ElseIf Programming = 1 And InStr(D(i).keywords, "programming") Then
         Flag = 1
      ElseIf Utilities = 1 And InStr(D(i).keywords, "utility") Then
         Flag = 1
      ElseIf Internet = 1 And InStr(D(i).keywords, "internet") Then
         Flag = 1
      End If

      If Flag = 0 Then
         Array Delete D(i)
         Incr iCount
       End If

   Next iCount
   'if any removed, resize the arrays
   If iCount Then
      i = UBound(D)-iCount
      ReDim Preserve D(i)
   End If
End Sub
Sub RemoveAppTypes
   Local i,iCount As Long
   'remove PB/VB apps as required
   iCount = 0
   If AppTypes <> %AllApps Then
      For i = UBound(D) To 1 Step -1
         Select Case AppTypes
            Case %PBApps
               If InStr(D(i).keywords, "vb6") Then
                  Array Delete D(i)
                  Incr iCount
               End If
            Case %VBApps
               If InStr(D(i).keywords, "powerbasic") Then
                  Array Delete D(i)
                  Incr iCount
               End If
         End Select
      Next iCount
      i = UBound(D)-iCount
      ReDim Preserve D(i)
   End If
End Sub

Sub LoadListView   'also searches
   Local i As Long
   LoadListViewInWork = 1
   ListView Reset hDlg, %IDC_ListView
   For i = 1 To UBound(D)
      ListView Insert Item hDlg, %IDC_ListView, i, 1, D(i).name
      ListView Set Text hDlg, %IDC_ListView, i, 2, D(i).ver
      ListView Set Text hDlg, %IDC_ListView, i, 3, D(i).date
      ListView Set Text hDlg, %IDC_ListView, i, 4, "  " + D(i).rating + "  "
      ListView Set Text hDlg, %IDC_ListView, i, 5, D(i).oneliner
   Next i
   LoadListViewInWork = 0
End Sub

Sub DisplaySelection
   If LoadListViewInWork Then Exit Sub
   Local iResult As Long, temp As WStringZ * %Max_Path, pf As ParaFormat, tmp$
   ListView Get Select hDlg, %IDC_ListView To iResult
   If iResult = 0 Then Exit Sub
   LastSelected = iResult

   'Description
   tmp$ = D(iResult).desc
   Replace $CrLf + $CrLf With ":::::" In tmp$
   Replace $CrLf With $Spc In tmp$
   Replace ":::::" With $CrLf + $CrLf In tmp$
   tmp$ = Shrink$(tmp$)
   Control Set Text hDlg, %IDC_Desc, tmp$

   'DBullets
   Control Set Text hDlg, %IDC_Bullets, D(iResult).bullets
   pf.cbSize      = SizeOf(pf)
   pf.dwMask      = %PFM_Numbering
   pf.wNumbering  = %PFN_Bullet
   SendMessage(GetDlgItem(hDlg,%IDC_Bullets), %EM_SetSel, 0, -1)
   SendMessage(GetDlgItem(hDlg,%IDC_Bullets), %EM_SETPARAFORMAT, 0, VarPtr(pf))
   SendMessage(GetDlgItem(hDlg,%IDC_Bullets), %EM_SetSel, -1, 0)

   'AppIcon
   Graphic Attach hDlg, %IDC_AppIcon, ReDraw
   Graphic Clear
   temp = D(iResult).icon
   Replace "/" With "\" In temp
   temp = Exe.Path$ + "appicons\" + PathName$(Namex,temp) '+ ".bmp"
   Graphic Render Icon, temp, (3,3)-(50,50)
   Graphic ReDraw

   'AppImage
   temp = Parse$(D(iResult).images,";",CurrentImage)
   Replace "/" With "\" In temp
   temp = Exe.Path$ + "appimages\" + PathName$(Namex,temp)

   LoadImage_GDIP temp, hBMP, 0
   DrawImage
End Sub

Function LoadImage_GDIP(sFileName As WStringZ * %Max_Path, targetHandle As Dword, targetID As Long) As Long
   'with Graphic Control   targetHandle is hDlg and %IDC_Graphic1
   'with Memory Bitmap     targetHandle is hBMP and 0
   'with Graphic Window    targetHandle is hWin and 0
   Local hr As Long, token As Dword, hDC As Dword
   Local hStatus As Long, pGraphics As Dword, pImage As Dword
   Local StartupInput As GdiplusStartupInput

   ' Initialize GDI+
   StartupInput.GdiplusVersion = 1
   hr = GdiplusStartup(token, StartupInput, ByVal %NULL)
   If hr Then Function = 0 : Exit Function   'return 0 if fails

   Graphic Attach targetHandle, targetID     ' Select the drawing target
   Graphic Get DC To hdc                     ' Retrieve the handle of the device context
   Graphic Color %Black, %White              ' Set the foreground and background color
   Graphic Clear                             ' Clear the entire selected graphic window

   hStatus = GdipLoadImageFromFile(sFileName, pImage)           ' Create the Image object
   hStatus = GdipCreateFromHDC(hDC, pGraphics)                  ' Create the Graphic object
   hStatus = GdipDrawImage(pGraphics, pImage, 0, 0)             ' Draw the image

   'get properties
   GdipGetImageWidth(pImage,imgW)
   GdipGetImageHeight(pImage,imgH)

   If pImage Then GdipDisposeImage(pImage)                      ' Cleanup
   If pGraphics Then GdipDeleteGraphics(pGraphics)              ' Cleanup
   GdiplusShutdown token                                        ' Shutdown GDI+

   Function = 1                                                 ' Success
End Function

Sub DrawImage
   Local w,h,x,y,wNew,hNew As Long
   'put image in center of IDC_ApImage
   Graphic Attach hDlg, %IDC_AppImage, ReDraw
   Graphic Clear
   Graphic Set StretchMode %HalfTone
   Graphic Get Client To w,h

   If Resize Then
      If ShrinkOnly And imgW <= w And imgH <= h Then
         If CenterImage Then
            If w > imgW Then x = (w-imgW)/2 Else x = 0
            If h > imgH Then y = (h-imgH)/2 Else y = 0
         End If
         Graphic Copy hBMP, 0, (0,0)-(imgW-1,imgH-1) To (x,y)
      Else
         wNew = imgW/Max(imgW/w, imgH/h)
         hNew = imgH/Max(imgW/w, imgH/h)
         If CenterImage Then
            x = (w-wNew)/2 : y = (h-hNew)/2               'upper/left position so resized image is centered
         End If
         Graphic Stretch hBMP, 0, (0,0)-(imgW-1,imgH-1) To (x,y)-(x+wNew-1,y+hNew-1)  'copy (resized) from memory bitmap to visible image
      End If
   Else
      If CenterImage Then
         If w > imgW Then x = (w-imgW)/2 Else x = 0
         If h > imgH Then y = (h-imgH)/2 Else y = 0
      End If
      Graphic Copy hBMP, 0, (0,0)-(imgW-1,imgH-1) To (x,y)
   End If
   Graphic ReDraw
End Sub

Sub PrintListView
   Local i,iCount,iPos As Long, temp$
   ListView Get Count hDlg, %IDC_ListView To iCount
   XPrint Attach Default
   For i = 1 To iCount
      If ListView_GetCheckState(hListView,i-1) = 0 Then Iterate For
      If iPos = 0 Then XPrint Cell = 3,1 : XPrint "gbCatalog Listing" : iPos = 4
      Incr iPos
                                                            XPrint Cell = iPos,5  : XPrint Format$(i,"00 ");
      ListView Get Text hDlg, %IDC_ListView, i,1 To temp$ : XPrint Cell = iPos,10 : XPrint temp$;
      ListView Get Text hDlg, %IDC_ListView, i,2 To temp$ : XPrint Cell = iPos,35 : XPrint temp$;
      ListView Get Text hDlg, %IDC_ListView, i,3 To temp$ : XPrint Cell = iPos,45 : XPrint temp$
      If iPos > 58 Then iPos = 0 : XPrint FormFeed
   Next
   XPrint Close
End Sub

Function GetURL (URLPath As WStringZ * %Max_Path, LocalPath As WStringZ * %Max_Path) As Long
   Local tempZ As WStringZ * %Max_Path
   tempZ = URLPath
   Replace "http://www.garybeene.com" With "..." In tempZ
   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Downloading ..." + tempZ
   DeleteURLCacheEntry(URLPath)     '1 = success  clear the cache
   If URLDownloadToFile (Nothing, (URLPath), LocalPath, 0, Nothing) = 0 Then Function = 1
   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Download complete ..." + tempZ
End Function

Sub RefreshOneIcon
   Local i As Long, temp$
   MousePtr 11
   ListView Get Select hDlg, %IDC_ListView To i
   temp$ = D(i).icon
   Replace "/" With "\" In temp$
   temp$ = Exe.Path$ + "appicons\" + PathName$(Namex,temp$)
   GetURL((D(i).icon),(temp$))
   MousePtr 1
End Sub

Sub RefreshIcons
   Local i As Long, temp$
   MousePtr 11
   For i = 1 To UBound(D)
      temp$ = D(i).icon
      Replace "/" With "\" In temp$
      temp$ = Exe.Path$ + "appicons\" + PathName$(Namex,temp$)
      GetURL((D(i).icon),(temp$))
   Next i
   MousePtr 1
End Sub

Sub RefreshOneImage
   Local i,j,iCount As Long, temp$, tmp, URL As WStringZ * %Max_Path
   MousePtr 11
   ListView Get Select hDlg, %IDC_ListView To i
   temp$ = D(i).images
   iCount = ParseCount(temp$,";")
   Replace "/" With "\" In temp$
   For j = 1 To iCount
      tmp = Exe.Path$ + "appimages\" + PathName$(Namex,Parse$(temp$,";",j))
      URL = Parse$(D(i).images,";",j)
      GetURL (URL, tmp)
   Next j
   MousePtr 1
End Sub

Sub RefreshImages
   Local i,j,iCount As Long, temp$, tmp, URL As WStringZ * %Max_Path
   MousePtr 11
   For i = 1 To UBound(D)
      temp$ = D(i).images
      iCount = ParseCount(temp$,";")
      Replace "/" With "\" In temp$
      For j = 1 To iCount
         tmp = Exe.Path$ + "appimages\" + PathName$(Namex,Parse$(temp$,";",j))
         URL = Parse$(D(i).images,";",j)
         GetURL (URL, tmp)
      Next j
   Next i
   MousePtr 1
End Sub

Sub DownloadCheckedZips
   Local i,iResult,iCount,iSize,iZips As Long, temp$

   If CheckCount = 0 Then
      MessageBox(0, "No apps checked!", "Download Apps", %MB_Ok + %MB_IconExclamation + %MB_TaskModal)
      Exit Sub
   End If

   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      If ListView_GetCheckState(hListView,i-1) = 0 Then Iterate For
      iSize = Val(D(i).keywords)
      iResult = 1
      If LargeFileWarning And iSize >= MaxFileSize Then
         ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
         If MessageBox(0,"Large file warning (" + Trim$(Str$(iSize)) + "MB!).  Download " + D(i).name + "?", "Download Apps", %MB_YesNo + %MB_IconQuestion + %MB_TaskModal) = %IdNo Then iResult = 0
         UnhookWindowsHookEx ghHook
      End If
      If iResult Then
         Incr iZips
         MousePtr 11
         temp$ = D(i).zip
         Replace "/" With "\" In temp$
         temp$ = Exe.Path$ + "downloads\" + PathName$(Namex,temp$)
         GetURL((D(i).zip),(temp$))
         MousePtr 1
      End If
   Next i

   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   MessageBox(0, "Apps downloaded: " + Str$(iZips), "Download Apps", %MB_Ok + %MB_IconExclamation + %MB_TaskModal)
   UnhookWindowsHookEx ghHook
End Sub

Sub UpdateDATFile
   Local iResult As Long, temp$
   DLPath = Exe.Path$ + "files\gbcatalog_new.dat"
   If GetURL("http://www.garybeene.com/files/gbcatalog.dat", (DLPath)) Then
      Open DLPath For Input As #1
      Line Input #1, temp$
      Close #1
      iResult = Val(temp$)
      If iResult > CatalogVer Then
         ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
         If MessageBox (0, "Update available. Download?", "Update Catalog Information", %MB_OkCancel + %MB_IconQuestion) = %IdOk Then
            FileCopy DLPath, Exe.Path$ + "files\gbcatalog.dat"
            Kill DLPath
            ReadDataFile
            SortData
            LoadListView
            ListView Select hDlg, %IDC_ListView, 1
            ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
            Control Set Focus hDlg, %IDC_ListView
            CurrentImage = 1
            GrayOutNextImage
            DisplaySelection
            UpdateStatusBar
            ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
            MessageBox(0, "Update to v" + Format$(CatalogVer,"0.00") + " was successful!", "Download Catalog Information", %MB_Ok Or %MB_IconInformation)
         End If
         UnhookWindowsHookEx ghHook
      Else
         ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
         MessageBox(0, "You already have the latest catalog information!", "Download Catalog Information", %MB_Ok Or %MB_IconInformation)
         UnhookWindowsHookEx ghHook
      End If
   Else
      ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
      MessageBox(0, "Catalog not found on server!", "Download Catalog", %MB_Ok Or %MB_IconExclamation)
      UnhookWindowsHookEx ghHook
   End If
End Sub

Sub CreateSubFolders
   If IsFolder (Exe.Path$ + "files") = %False Then MkDir Exe.Path$ + "files"
   If IsFolder (Exe.Path$ + "appicons") = %False Then MkDir Exe.Path$ + "appicons"
   If IsFolder (Exe.Path$ + "appimages") = %False Then MkDir Exe.Path$ + "appimages"
   If IsFolder (Exe.Path$ + "downloads") = %False Then MkDir Exe.Path$ + "downloads"
End Sub

Function SBProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long    'MsgBox is approximately 200x200
   CenterOverDialog 200,200,x,y
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

Sub CenterOverDialog(BoxX As Long, BoxY As Long, CenterX As Long, CenterY As Long)
   'gets top/left position to center Box over Dialog
   'you need to know, or at least estimate, the Box size
   Local x As Long, y As Long, w As Long, h As Long
   Dialog Get Loc hDlg To x,y
   Dialog Get Size hDlg To w,h
   CenterX = x + (w-BoxX)/2
   CenterY = y + (h-BoxY)/2
End Sub

Sub GrayoutNextImage
   Local iResult As Long, temp$
   ListView Get Select hDlg, %IDC_ListView To iResult
   If iResult Then
      temp$ = D(iResult).images
      If ParseCount(temp$,";") > 1 Then
         Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_NextImage, %TBState_Enabled
      Else
         Toolbar Set State hDlg, %IDC_Toolbar, ByCmd %IDT_NextImage, %TBState_Disabled
      End If
   End If
End Sub

Sub DisplayWaitDialog(hParent As Dword, Msg$)
   Local x As Long, y As Long, w As Long, h As Long, wX As Long, wY As Long
   Dialog Get Client hParent To w,h
   wX = 260 : wY = 80
   x = (w-wX)/2    'gets left position of WaitDialog to center over app
   y = (h-wY)/2    'gets top position of WaitDialog to center over app
   Dialog New Pixels, hDlg, "", x, y, wX, wY, %WS_Popup To hWait
   Control Add Label, hWait, %IDC_LabelWait, Msg$ + $CrLf + "   Please wait ... ", 0, 0, wX, wY, %SS_Center Or %SS_CenterImage Or %WS_Border
   Control Set Font hWait, %IDC_LabelWait, hFont
   Control Set Color hWait, %IDC_LabelWait, %Black, %rgb_LightBlue
   Dialog Show Modeless hWait
End Sub

Function SortARating(R As AppData, S As AppData) As Long
   If R.Rating < S.Rating Then Function = -1 : Exit Function
   If R.Rating > S.Rating Then Function = +1 : Exit Function
End Function

Function SortDRating(R As AppData, S As AppData) As Long
   If R.Rating < S.Rating Then Function = +1 : Exit Function
   If R.Rating > S.Rating Then Function = -1 : Exit Function
End Function

Function SortAName(R As AppData, S As AppData) As Long
   If LCase$(R.name) < LCase$(S.name) Then Function = -1 : Exit Function
   If LCase$(R.name) > LCase$(S.name) Then Function = +1 : Exit Function
End Function

Function SortDName(R As AppData, S As AppData) As Long
   If LCase$(R.name) < LCase$(S.name) Then Function = +1 : Exit Function
   If LCase$(R.name) > LCase$(S.name) Then Function = -1 : Exit Function
End Function

Function SortAVersion(R As AppData, S As AppData) As Long
   If LCase$(R.ver) < LCase$(S.ver) Then Function = -1 : Exit Function
   If LCase$(R.ver) > LCase$(S.ver) Then Function = +1 : Exit Function
End Function

Function SortDVersion(R As AppData, S As AppData) As Long
   If LCase$(R.ver) < LCase$(S.ver) Then Function = +1 : Exit Function
   If LCase$(R.ver) > LCase$(S.ver) Then Function = -1 : Exit Function
End Function

Function SortADate(R As AppData, S As AppData) As Long
   If LCase$(R.date) < LCase$(S.date) Then Function = -1 : Exit Function
   If LCase$(R.date) > LCase$(S.date) Then Function = +1 : Exit Function
End Function

Function SortDDate(R As AppData, S As AppData) As Long
   If LCase$(R.date) < LCase$(S.date) Then Function = +1 : Exit Function
   If LCase$(R.date) > LCase$(S.date) Then Function = -1 : Exit Function
End Function

Function SortAOneLiner(R As AppData, S As AppData) As Long
   If R.oneliner < S.oneliner Then Function = -1 : Exit Function
   If R.oneliner > S.oneliner Then Function = +1 : Exit Function
End Function

Function SortDOneLiner(R As AppData, S As AppData) As Long
   If R.oneliner < S.oneliner Then Function = +1 : Exit Function
   If R.oneliner > S.oneliner Then Function = -1 : Exit Function
End Function

Sub ValidateServerFiles
   On Error Resume Next
   Local i,j,iCount,Flag As Long, temp$
   MousePtr 11
   For i = 1 To UBound(D)
      Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Validating URLs for " + D(i).name + " ..." + "   App " + Str$(i) + " of" + Str$(UBound(D)) + "   Please wait ..."
      Flag = 0
      If URLExists(D(i).zip) = 0 Then temp$ = temp$ + $CrLf + D(i).zip : Flag = 1 : Incr iCount
      If URLExists(D(i).homepage) = 0 Then temp$ = temp$ + $CrLf + D(i).homepage : Flag = 1 : Incr iCount
      If URLExists(D(i).icon) = 0 Then temp$ = temp$ + $CrLf + D(i).icon : Flag = 1 : Incr iCount
      For j = 1 To ParseCount(D(i).images,";")
         If URLExists(Parse$(D(i).images,";",j)) = 0 Then temp$ = temp$ + $CrLf + Parse$(D(i).images,";",j) : Flag = 1 : Incr iCount
      Next j
      If Flag Then temp$ = temp$ + $CrLf
   Next i
   MousePtr 1
   Statusbar Set Text hDlg, %IDC_StatusBar, 1,0, "Validation complete.    Bad URLs: " + Str$(iCount)
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   Open Exe.Path$ + "files\BadURLs.txt" For Output As #1
   Print #1, Str$(iCount) + " failed URLs" + $CrLf + $CrLf + temp$
   Close #1
   i = Shell ("Notepad " + Exe.Path$ + "files\BadURLs.txt", 1)  'opens Notepad, does not wait for it to close
End Sub

Function URLExists(URL As StringZ * %Max_Path) As Long
   On Error GoTo URLError
   Local Buffer$
   Tcp Open "HTTP" At "www.garybeene.com" As #1 TimeOut 60000
   Tcp Print #1, "HEAD  " + URL + "  HTTP/1.0"
   Tcp Print #1, ""
   Tcp Recv #1, 4096, Buffer$
   Tcp Close #1
   If InStr( Parse$(Buffer$,$CrLf,1), "OK") Then Function = 1
   Exit Function
URLError:
End Function

Sub DisplayDescription
   Local iResult As Long
   ListView Get Select hDlg, %IDC_ListView To iResult
   If iResult = 0 Then Exit Sub
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(SBProc), GetModuleHandle(""), GetCurrentThreadId)
   MessageBox (0, (D(iResult).desc), "Application Information", %MB_Ok + %MB_IconInformation)
   UnhookWindowsHookEx ghHook
End Sub

Sub UpdateStatusBar
   Local i,iCount,iResult As Long
   ListView Get Count hDlg, %IDC_ListView To iCount
   ListView Get Select hDlg, %IDC_ListView To iResult
   Statusbar Set Text hdlg, %IDC_StatusBar, 1,0, "  " + D(iResult).name
   Statusbar Set Text hdlg, %IDC_StatusBar, 2,0, "  Image: " + Str$(CurrentImage) + " of" + Str$(ParseCount(D(iResult).images,";"))
   Statusbar Set Text hdlg, %IDC_StatusBar, 3,0, "  Apps in list: " + Str$(iCount)
End Sub

Sub SortData
   If UBound(D) = 0 Then Exit Sub
   If SortDirection = 0 Then
      If SortColumnX = 1 Then Array Sort D(1), Call SortAName
      If SortColumnX = 2 Then Array Sort D(1), Call SortAVersion
      If SortColumnX = 3 Then Array Sort D(1), Call SortADate
      If SortColumnX = 4 Then Array Sort D(1), Call SortARating
      If SortColumnX = 5 Then Array Sort D(1), Call SortAOneLiner
   Else
      If SortColumnX = 1 Then Array Sort D(1), Call SortDName
      If SortColumnX = 2 Then Array Sort D(1), Call SortDVersion
      If SortColumnX = 3 Then Array Sort D(1), Call SortDDate
      If SortColumnX = 4 Then Array Sort D(1), Call SortDRating
      If SortColumnX = 5 Then Array Sort D(1), Call SortDOneLiner
   End If
   SetHeaderIconsOnRight SortColumnX-1
End Sub

Sub SetHeaderIconsOnRight(ByVal iActiveColumn As Integer)
   Local i, iAlignRight As Integer, hdi As HD_ITEM
   For i = 0 To Header_GetItemCount(hHeader) - 1
      hdi.mask = %HDI_FORMAT Or %HDI_IMAGE
      hdi.fmt = %HDF_String Or %HDF_Image Or %HDF_Bitmap_On_Right
      If i = iActiveColumn Then hdi.iImage = SortDirection Else hdi.iImage = 3
      Header_SetItem(hHeader, i, hdi)
   Next
End Sub

Sub CreateListView
   Control Add ListView, hDlg, %IDC_ListView,"", 10,60,600,250, %WS_TabStop Or %LVS_Report Or %LVS_ShowSelAlways Or %LVS_SingleSel, %WS_Ex_Left Or %WS_Ex_ClientEdge
   Control Handle hDlg, %IDC_ListView To hListView
   ListView Insert Column hDlg, %IDC_ListView, 1, "Name", 150, 0
   ListView Insert Column hDlg, %IDC_ListView, 2, "Ver", 60, 2
   ListView Insert Column hDlg, %IDC_ListView, 3, "Date", 85, 2
   ListView Insert Column hDlg, %IDC_ListView, 4, "Rank", 70, 2
   ListView Insert Column hDlg, %IDC_ListView, 5, "Description", 340, 0
   ListView Set StyleXX hDlg, %IDC_ListView, %LVS_Ex_GridLines Or %LVS_Ex_FullRowSelect Or %LVS_Ex_DoubleBuffer Or %LVS_Ex_CheckBoxes

   'create imagelist
   ImageList New Icon 16,16,24,3 To hImageList
   ImageList Add Icon hImageList, "xup"
   ImageList Add Icon hImageList, "xdown"

   'assign imagelist to header
   hHeader = ListView_GetHeader(hListView)
   Header_SetImageList hHeader, hImagelist
End Sub

Function CheckCount() As Long
   Local i, iCount, iResult As Long
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      iResult += ListView_GetCheckState(hListView,i-1)
   Next i
   Function = Abs(iResult)
End Function

Function ImageCount() As Long
   Local i, iCount, iResult As Long
   ListView Get Count hDlg, %IDC_ListView To iCount
   For i = 1 To iCount
      If ListView_GetCheckState(hListView,i-1) Then iResult += ParseCount(D(i).images,";")
   Next i
   Function = iResult
End Function

Sub SaveURLList
   Local i,j,iCount As Long
   Open "files\urllist.txt" For Output As #1
   For i = 1 To UBound(D)
      Print #1, D(i).homepage
      Print #1, D(i).icon
      For j = 1 To ParseCount(D(i).images,";")
         Print #1, Parse$(D(i).images,";",j)
      Next j
   Next i
   Close #1
End Sub

Sub ExportCatalog(fName$, CheckedOnly As Long)
   Local i As Long, temp$
   Open fName$ For Output As #1
   Print #1, Format$(CatalogVer,"0.00") + "    'Created: " + Date$ + " " + Time$
   For i = 1 To UBound(D)
      If CheckedOnly And ListView_GetCheckState(hListView,i-1) = 0 Then Iterate For
      Print #1, "=000============================================"
      Print #1, D(i).name
      Print #1, D(i).ver
      Print #1, D(i).date
      Print #1, D(i).homepage
      Print #1, D(i).icon
      Print #1, D(i).zip
      Print #1, D(i).oneliner
      Print #1, D(i).keywords
      Print #1, D(i).rating + " stars"
      Print #1, D(i).author
      Print #1, "=111============================================"
      Print #1, D(i).bullets
      Print #1, "=111============================================"
      Print #1, "=222============================================"
      Print #1, D(i).desc
      Print #1, "=222============================================"
      Print #1, "=333============================================"
      temp$ = D(i).images
      Replace ";" With $CrLf In temp$
      Print #1, temp$
      If i = UBound(D) Then
         Print #1, "=333============================================";
      Else
         Print #1, "=333============================================"
      End If
   Next i
   Close #1
End Sub

Sub DisplaySearchDialog
   Dialog Font "Tahoma",10,0
   Dialog New Pixels, hDlg, "Find", 100, 100, 250, 70, %WS_SysMenu Or %WS_Caption Or %WS_ClipChildren To hDlgS
   Dialog Set Icon hDlgS, "xsearch"

   Control Add Label, hDlgS, %IDS_FindThisLabel, "Find This:", 5, 10, 80, 20
   Control Add TextBox, hDlgS, %IDS_FindThis, SearchTerm, 90, 10, 150, 25, %WS_TabStop Or %WS_Border Or %ES_AutoHScroll, %WS_Ex_ClientEdge
   Control Add CheckBox, hDlgS, %IDS_CaseSensitive, "Case Sensitive", 10, 40, 100, 20
   Control Set Check hDlgS, %IDS_CaseSensitive, CaseSensitive
   Control Add Button, hDlgS, %IdOk, "Ok", 200, 230, 20, 20
   Control Add Button, hDlgS, %IdCancel, "Cancel", 230, 230, 20, 20
   Control Show State hDlgS, %IdOk, %SW_Hide
   Control Show State hDlgS, %IdCancel, %SW_Hide

   SearchDialogShown = 1
   Dialog Show Modeless hDlgS Call Search_DlgProc()
   Do                                                                    'because we want to be able
      Dialog DoEvents                                                     'to edit main text while
   Loop Until SearchDialogShown = 0

End Sub

CallBack Function Search_DlgProc() As Long
   Select Case Cb.Msg
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDS_FindThis   : If Cb.CtlMsg = %EN_Change Then Control Get Text hDlgS, %IDS_FindThis To SearchTerm
            Case %IDS_CaseSensitive   : Control Get Check hDlgS, %IDS_CaseSensitive To CaseSensitive
            Case %IdCancel            : SearchDialogShown = 0   : Dialog End hDlgS
            Case %IdOk                : ReadDataFile : SortData : SearchCatalog
         End Select
      Case %WM_Destroy                : SearchDialogShown = 0 : Control Set Focus hDlg, %IDC_ListView
   End Select
End Function

Function SearchCatalog() As Long
   Local i,j,iResult,iRow,iMax As Long, sTerm$, mTerm$, temp$



   ListView Get Select hDlg, %IDC_ListView To iRow
   sTerm$ = IIf$(CaseSensitive,SearchTerm,LCase$(SearchTerm))
   If sTerm$ <> "..." Then
      For i = 1 To UBound(D)
         iResult = 0
         If InStr(IIf$(CaseSensitive,D(i).name,LCase$(D(i).name)),sTerm$)         Then
            iResult = 1
         ElseIf InStr(IIf$(CaseSensitive,D(i).author,LCase$(D(i).author)),sTerm$)   Then
            iResult = 1
         ElseIf InStr(IIf$(CaseSensitive,D(i).date,LCase$(D(i).date)),sTerm$)     Then
            iResult = 1
         ElseIf InStr(IIf$(CaseSensitive,D(i).oneliner,LCase$(D(i).oneliner)),sTerm$) Then
            iResult = 1
         ElseIf InStr(IIf$(CaseSensitive,D(i).desc,LCase$(D(i).desc)),sTerm$) Then
            iResult = 1
         ElseIf InStr(IIf$(CaseSensitive,D(i).keywords,LCase$(D(i).keywords)),sTerm$)     Then
            iResult = 1
         ElseIf InStr(IIf$(CaseSensitive,D(i).bullets,LCase$(D(i).bullets)),sTerm$)  Then
            iResult = 1
         End If
         If iResult Then Incr iMax : D(iMax) = D(i)
     Next i
     If iMax Then
        ReDim Preserve D(iMax)
        LoadListView
        ListView Select hDlg, %IDC_ListView, 1
        ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
        DisplaySelection
        UpdateStatusBar
     Else
        Beep
     End If
     Control Send hDlgS, %IDS_FindThis, %EM_SetSel, 0, -1
   Else
     SetMenuStatus
     ReadDataFile
     SortData
     LoadListView
     ListView Select hDlg, %IDC_ListView, 1
     ListView_SetItemState hListView, 0, %LVIS_Focused, %LVIS_Focused  '<--- keyboard synchronizing code
     DisplaySelection
     UpdateStatusBar
     Dialog End hDlgS
   End If
End Function
